
from comon import *


filteration = Blueprint('filteration', __name__)




@filteration.route('/addFilter', methods=['POST'])
@cross_origin(supports_credentials=True)
def addFilter():
    _json = request.json
    cursor = connect_mysql().cursor()
    try:
        channelNewId  = _json['channelId']
        verticalId = _json['verticalId']
        moduleId = _json['moduleId']
        month = _json['month']
        year = _json['year']
        columnId = _json['columnNameId']
        operation = _json['filterOperator']
        searchedValue = _json['searchedValue']

        insert_sql = " INSERT INTO `mappingFilter`(`channelNewId`, `verticalId`, `moduleId`, `columnId`, `operation`, `value`) VALUES (%s,%s,%s,%s,%s,%s) "
        cursor.execute(insert_sql,(channelNewId,verticalId,moduleId,columnId,operation,searchedValue))
        resp = jsonify({'success' : True, 'message' : " Insert Successful"})
    except Exception as e:
        print(e)
        resp = jsonify({'success' : False, 'message' : "Failed to Insert"})
    finally:
        cursor.close()
        return resp
    

@filteration.route('viewFilter',methods = ['POST'])
@cross_origin(supports_credentials=True)
def viefFilter():
    _json = request.json
    cursor = connect_mysql().cursor()
    try:
        # payload : channelId,verticalId,moduleId,month,year by defalult 'all'
        channelNewId  = _json['channelId']
        verticalId = _json['verticalId']
        moduleId = _json['moduleId']
        month = _json['month']
        year = _json['year']

        search_sql = "SELECT mf.*,ch.channelNewName,vm.verticalName,um.moduleName,col.columnName FROM `mappingFilter` mf LEFT JOIN channelNewMaster  ch ON mf.channelNewId = ch.id LEFT JOIN verticalM vm on mf.verticalId = vm.id LEFT JOIN uploadModuleM um ON mf.moduleId = um.id LEFT JOIN uploadModuleColMapping col on mf.columnId = col.id WHERE mf.active = 1 "

        if channelNewId != 'all' and channelNewId != '' and channelNewId != None:
            search_sql += " AND mf.channelNewId = "+str(channelNewId)

        if verticalId != 'all' and verticalId != '' and verticalId != None:
            search_sql += " AND mf.verticalId = "+str(verticalId)

        if moduleId != 'all' and moduleId != '' and moduleId != None:
            search_sql += " and mf.moduleId = "+str(moduleId)

        print("search_sql-------> ",search_sql)
        cursor.execute(search_sql)
        result = cursor.fetchall()
        resp = jsonify({'success':True, 'message': "Fetch Successfully","result":result})
    except Exception as e:
        print(e)
        resp = jsonify({'success' : False, 'message' : "Failed to fetch"})
    finally:
        cursor.close()
        return resp
    
@filteration.route('editFilter',methods = ['POST'])
@cross_origin(supports_credentials=True)
def editFilter():
    _json = request.json
    cursor = connect_mysql().cursor()
    try:
        id  = _json['id']
        operation = _json['filterOperator']
        searchedValue = _json['searchedValue']
        deleteFlag = _json['deleteFlag']
        message = ''
        if deleteFlag == 0:
            update_sql = " UPDATE `mappingFilter` SET `operation`= '"+ str(operation) +"',`value`= '"+(searchedValue)+"' WHERE id = "+str(id)
            message = ' Updated Successfully'

        else:
            update_sql =" UPDATE `mappingFilter` SET  active = 0 WHERE id = "+str(id)
            message = ' Deleted Successfully'
        print(update_sql)


        cursor.execute(update_sql)

        resp = jsonify({'success':True, 'message':message})
    except Exception as e:
        print(e)
        resp = jsonify({'success' : False, 'message' : "Failed to fetch"})
    finally:
        cursor.close()
        return resp